uint8_t turnInMaze(MyRobot_t robot) {
  //value = pgm_read_byte_near(turn_table + index);
  uint8_t index = (robot.turn << 2) + robot.dir;
  uint8_t curr_dir = pgm_read_byte_near(turn_table + index);
  return curr_dir;
}

MyRobot_t stepInMaze(MyRobot_t robot) {
  //row
  uint8_t index = (robot.dir << 1);
  robot.row = robot.row + pgm_read_byte_near(map_table + index);
  //col
  robot.col = robot.col + pgm_read_byte_near(map_table + index + 1);
  return robot;
}

MyRobot_t roomInMaze(MyRobot_t robot) {
  uint16_t index = ((robot.row * 0x15) + robot.col);
  uint16_t newRoom = pgm_read_byte_near(theMaze + index);
  //Serial.print("index = ");
  //Serial.println(index);
  //Serial.print("Mazedata= ");
  //Serial.println(newRoom);
  robot.room = newRoom & 0x0F;
  robot.bees = ((newRoom & 0xF0) >> 4);
  return robot;
}

bool HitWall(MyRobot_t robot) {
  static bool hitwall = false;
  uint16_t room = robot.room;
  switch (robot.dir) {
    case 0: //dir = 0b00
      room = room >> 3; //take the south wall bit and shift to LSB
      hitwall = (room & 0x01); // AND the room and 1, hitwall = 0 for no wall and =1 for yes wall
      return hitwall;
      break;

    case 1: //dir = 0b01
      room = room >> 1; //take the east wall bit and shift to LSB
      hitwall = (room & 0x01);  // AND the room and 1, hitwall = 0 for no wall and =1 for yes wall
      return hitwall;
      break;

    case 2: //dir = 0b10
      room = room >> 2; //take the west wall bit and shift to LSB
      hitwall = (room & 0x01); // AND the room and 1, hitwall = 0 for no wall and =1 for yes wall
      return hitwall;
      break;

    case 3: //dir = 0b11
      room = room >> 0; //take the north wall bit and shift to LSB
      hitwall = (room & 0x01); // AND the room and 1, hitwall = 0 for no wall and =1 for yes wall
      return hitwall;
      break;
  }
}

bool LeftPaw(MyRobot_t robot) {
  robot.turn = 0b10;
  robot.dir = turnInMaze(robot);
  bool LeftPaw = HitWall(robot);
  robot.turn = 0b01;
  robot.dir = turnInMaze(robot);
  return LeftPaw;
}

bool RightPaw(MyRobot_t robot) {
  robot.turn = 0b01;
  robot.dir = turnInMaze(robot);
  bool RightPaw = HitWall(robot);
  robot.turn = 0b10;
  robot.dir = turnInMaze(robot);
  return RightPaw;
}

void altWW(MyRobot_t robot) {
    static MyRobot_t test{0x03 , 0x00, 0x12, 0x00, 0x00, 0x00};

  static bool isIntersect;
  static bool lastState;
    static uint8_t B = 0; //initialize increment variable
  static uint8_t A = 1; //initialize increment variable

  tcaselect(0);
  uint16_t IR = uv.readIR();

  tcaselect(1);
  uint16_t IR1 = uv1.readIR();
  uint16_t motorASpeed = IR / 4;
  uint16_t motorBSpeed = IR1 / 4;
  if (motorASpeed < minSpeed) {
    motorASpeed = minSpeed;
  }
  if (motorBSpeed < minSpeed) {
    motorBSpeed = minSpeed;
  }
      static uint16_t PmotorSpeed = 0.5 * (motorASpeed + motorBSpeed); // initializes the variable that stores the motor speed the last time through the loop

  do{
      while (IR < black && IR1 < black) {
        if (lastState != isIntersect)
        {
          bool Hitwall = HitWall(test);
          bool Leftpaw = LeftPaw(test);
          bool Rightpaw = RightPaw(test);

          if (Hitwall == 0 && Leftpaw == 0 && Rightpaw == 0) // cond 000
          {
            //        Serial.println("cond 000");
            test.turn = 0b00; //no turn
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
          }
          else if (Leftpaw == 0 && Hitwall == 0 && Rightpaw == 1) //cond 001
          {
            //        Serial.println("cond 001");
            B++; //increment B
            test.turn = 0b00;
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
          }
          else if (Leftpaw == 0 && Hitwall == 1 && Rightpaw == 0) //cond 010
          {
            test.turn = 0b00;
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
          }
          else if (Leftpaw == 0 && Hitwall == 1 && Rightpaw == 1) //cond 011
          {
            //        Serial.println("cond 011");
            test.turn = 0b10; //Turn Left
            GyroLeft();
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
            test.turn = 0b00; // reset turn variable to no turn
          }
          else if (Leftpaw == 1 && Hitwall == 0 && Rightpaw == 0) //cond 100
          {
            A++; //increment A
            //        Serial.println("cond 100");
            //        Serial.println(N);
            test.turn = 0b01; //Turn Right
            GyroRight();
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
            test.turn = 0b00; // reset turn variable to no turn
          }
          else if (Leftpaw == 1 && Hitwall == 0 && Rightpaw == 1)//cond 101
          {
            //        Serial.println("cond 101");
            test.turn = 0b00; //no turn
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
          }
          else if (Leftpaw == 1 && Hitwall == 1 && Rightpaw == 0)//cond 110
          {
            //        Serial.println("cond 110");
            test.turn = 0b01; //Turn Right
            GyroRight();
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
            test.turn = 0b00; // reset turn variable to no turn
          }
          else if (Leftpaw == 1 && Hitwall == 1 && Rightpaw == 1) // cond 111
          {
            //        Serial.println("cond 111");
            test.turn = 0b11; //Turn around
            GyroAround();
            test.dir = turnInMaze(test);
            test = stepInMaze(test);
            test = roomInMaze(test);
            test.turn = 0b00; // reset turn variable to no turn
          }
        }
        else {

          analogWrite(PWMA, PmotorSpeed); // command motors to turn at the previous motor speed from before intersection
          analogWrite(PWMB, PmotorSpeed); // command motors to turn at the previous motor speed from before intersection
          delay(10);
        }
        lastState = isIntersect; // keeps track of isIntersect for the next time through this while loop, used to see if isIntersect changed.

        tcaselect(0);
        IR = uv.readIR();

        tcaselect(1);
        IR1 = uv1.readIR();
      }
      isIntersect = LOW;
      analogWrite(PWMA, motorBSpeed); // command the motors to turn at a given speed
      analogWrite(PWMB, motorASpeed); // command the motors to turn at a given speed
      delay(10);
      PmotorSpeed = 0.5 * (motorASpeed + motorBSpeed);
      lastState = isIntersect; // keeps track of isIntersect for the next time through the main loop, used to see if isIntersect changed.
      delay(10);
    } while (robot.row > 0);  

}

